package net.androidbootcamp.agameortwo;

import java.util.Arrays;
import java.util.Collections;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;
import android.support.v4.app.NavUtils;

public class Minesweeper extends Activity {
    int row = 8;
    int col = 8;
    LinearLayout rll[] = new LinearLayout[row];
    Button cell[] = new Button[row*col];
    Button btnNewGame;
    String counts[] = new String[row*col];
    
	//http://www.dreamincode.net/forums/topic/130521-android-part-iii-dynamic-layouts/
    //http://stackoverflow.com/questions/5510490/click-events-for-dynamic-array-of-buttons
	//http://stackoverflow.com/questions/3412180/how-to-determine-which-button-pressed-on-android
    //http://stackoverflow.com/questions/4948914/problem-with-setlayoutparams-method-in-android-ui
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //setContentView(R.layout.activity_main);
        ScrollView sv = new ScrollView(this);  

        LinearLayout ll = new LinearLayout(this);  
         
        ll.setOrientation(LinearLayout.VERTICAL);  
        sv.addView(ll);  
         
        for(int i=0; i<row; i++){
        	rll[i] = new LinearLayout(this);
        	rll[i].setOrientation(LinearLayout.HORIZONTAL); 
        	for(int j=0; j<col; j++){
        		cell[i*col+j] = new Button(this);
        		LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams(60, 60); 
        		cell[i*col+j].setLayoutParams(lp); 
        		((Button) cell[i*col+j]).setOnClickListener(myClickListener);
        		rll[i].addView(cell[i*col+j]);
        	}
        	ll.addView(rll[i]);
        }
        btnNewGame = new Button(this);
        btnNewGame.setText("Play again?");
        ll.addView(btnNewGame);

        
        btnNewGame.setOnClickListener(bNewGame);
        
        this.setContentView(sv);  
        setupGame();
    }

    //********************************************************************************
    private void setupGame(){
    	int i, bombNumber, myRow, myCol, myCount;
    	bombNumber =(int) (0.15625*row*col);
    	for(i=0;i<bombNumber;i++){
    		counts[i]="b";
    	}
    	for(i=bombNumber;i<row*col;i++){
    		counts[i]="";
    	}
    	Collections.shuffle(Arrays.asList(counts));
    	
    	for(i=0;i<row*col;i++){
    		myRow = i / col;
    		myCol = i % col;
    		
    		myCount=0;
    		
    		//row above
    		if(myRow!=0){
    			if(myCol!=0){
    				if(counts[i-col-1]=="b"){
    					myCount++;
    				}
    			}
    			
				if(counts[i-col]=="b"){
					myCount++;
				}
				
    			if(myCol!=col-1){
    				if(counts[i-col+1]=="b"){
    					myCount++;
    				}
    			}
    		}//end if not at top row
    		
    		
    		//same row
    		if(myCol!=0){
				if(counts[i-1]=="b"){
					myCount++;
				}
			}
		
			
			if(myCol!=col-1){
				if(counts[i+1]=="b"){
					myCount++;
				}
			}
			
    		//row below
    		if(myRow!=row-1){
    			if(myCol!=0){
    				if(counts[i+col-1]=="b"){
    					myCount++;
    				}
    			}
    			
				if(counts[i+col]=="b"){
					myCount++;
				}
				
    			if(myCol!=col-1){
    				if(counts[i+col+1]=="b"){
    					myCount++;
    				}
    			}
    		}//end if not at bottom row
			
    		if(!counts[i].equals("b")){
    			counts[i]=""+myCount;
    		}
    		
    	}//end for loop
    	
    	
    	//clear board of any previous game
    	for(i=0;i<row*col;i++){
    		//cell[i].setText(counts[i]);
    		cell[i].setText("");
    	}
    	
        btnNewGame.setVisibility(View.INVISIBLE);
    }
    
    
    Button.OnClickListener bNewGame = new Button.OnClickListener(){
    	public void onClick(View v){
    		setupGame();
    	}
    };
    
    //*********************************************************************************
    Button.OnClickListener myClickListener = new Button.OnClickListener(){
    	 
    	public void onClick(View v){
    		int myIndex, myRow, myCol;
    		
    		Button myButton = (Button) v;
    		
    		myIndex = Arrays.asList(cell).indexOf(myButton);
    		//myRow = myIndex / col;
    		//myCol = myIndex % col;
    		
  
    		
    		//Toast.makeText(MainActivity.this,counts[myIndex],Toast.LENGTH_LONG).show(); 
    		
    		myButton.setText(counts[myIndex]);
    		if(counts[myIndex].equals("b")){
    			//game over
    			Toast.makeText(Minesweeper.this,"Game Over",Toast.LENGTH_LONG).show();
    	        btnNewGame.setVisibility(View.VISIBLE);
    		}
    		
    		//myButton.setText(""+myRow +","+myCol);
    	}
    	
    };
    
    //********************************************************************************
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }

    
}
